<template>
  <div class="relative">
    <button class="" @click="toggleFilterDropdown()">
      <img src="~/assets/img/filter-icon.svg" class="w-5 h-5">
    </button>
    <div v-if="isFilterDropdownVisible" class="absolute right-0 top-5 bg-white dark:bg-gray-700 dark:text-gray-900 p-4 shadow-xl">
      <input
        ref="userInput"
        v-model="userInput"
        type="text"
        placeholder="Suchbegriff eingeben"
        class="w-44 h-8 px-3"
        @blur="handleInputChange()"
        @keydown.enter="close()"
      >
      <button class="block mt-2 ml-auto text-xs text-gray-400" @click="handleClear">
        Clear
      </button>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    filterValue: {
      type: String,
      default: ''
    }
  },

  data () {
    return {
      isFilterDropdownVisible: false,
      userInput: ''
    };
  },

  methods: {
    close (): void {
      this.isFilterDropdownVisible = false;
    },

    handleClear (): void {
      if (this.userInput) {
        this.userInput = '';
        this.handleInputChange();
        this.close();
      }
    },

    handleInputChange (): void {
      this.$emit('filter-change', this.userInput);
    },

    toggleFilterDropdown (): void {
      this.isFilterDropdownVisible = !this.isFilterDropdownVisible;

      if (this.isFilterDropdownVisible) {
        this.userInput = this.filterValue;

        this.$nextTick(() => {
          (this.$refs.userInput as any).focus();
        });
      }
    }
  }
});
</script>
